#!/bin/sh
#
# Copyright (c) 2003-2006 University of Utah and the Flux Group.
# 
# {{{EMULAB-LICENSE
# 
# This file is part of the Emulab network testbed software.
# 
# This file is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or (at
# your option) any later version.
# 
# This file is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public
# License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this file.  If not, see <http://www.gnu.org/licenses/>.
# 
# }}}
#

TMPSUDOERS=/tmp/sudoers
ME=`whoami`

rm -f $TMPSUDOERS

cat > $TMPSUDOERS <<EOF
# sudoers file.
#
# This file MUST be edited with the 'visudo' command as root.
#
# See the sudoers man page for the details on how to write a sudoers file.
#

# Host alias specification

# User alias specification

# Cmnd alias specification

# Defaults specification

# User privilege specification
root    ALL=(ALL) ALL
$ME     ALL=(ALL) NOPASSWD: ALL
%root   ALL=(ALL) NOPASSWD: ALL
EOF

su -c "install -c -m 440 $TMPSUDOERS /etc/sudoers"

# hack to ensure non-root users can't overwrite /etc/slicename
# XXX: shouldn't go here, but it's easy!
su -c "chmod 664 /etc/slicename"

exit $?
